/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.storage.jooq.tables.SentSms;
import com.flamesgroup.unit.ICCID;
import com.flamesgroup.unit.sms.DeliveryStatuses;
import com.flamesgroup.unit.sms.SMSEncoding;
import com.flamesgroup.unit.sms.SMSMessageClass;

import java.util.Date;
import java.util.UUID;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record14;
import org.jooq.Row14;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class SentSmsRecord extends UpdatableRecordImpl<SentSmsRecord> implements Record14<Integer, ICCID, UUID, String, String, String, SMSMessageClass, SMSEncoding, Date, Integer, Integer, Integer, Boolean, DeliveryStatuses> {

	private static final long serialVersionUID = -928673271;

	/**
	 * Setter for <code>public.sent_sms.id</code>.
	 */
	public SentSmsRecord setId(Integer value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.id</code>.
	 */
	public Integer getId() {
		return (Integer) getValue(0);
	}

	/**
	 * Setter for <code>public.sent_sms.iccid</code>.
	 */
	public SentSmsRecord setIccid(ICCID value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.iccid</code>.
	 */
	public ICCID getIccid() {
		return (ICCID) getValue(1);
	}

	/**
	 * Setter for <code>public.sent_sms.sms_id</code>.
	 */
	public SentSmsRecord setSmsId(UUID value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.sms_id</code>.
	 */
	public UUID getSmsId() {
		return (UUID) getValue(2);
	}

	/**
	 * Setter for <code>public.sent_sms.sms_center_number</code>.
	 */
	public SentSmsRecord setSmsCenterNumber(String value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.sms_center_number</code>.
	 */
	public String getSmsCenterNumber() {
		return (String) getValue(3);
	}

	/**
	 * Setter for <code>public.sent_sms.recipient_phone_number</code>.
	 */
	public SentSmsRecord setRecipientPhoneNumber(String value) {
		setValue(4, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.recipient_phone_number</code>.
	 */
	public String getRecipientPhoneNumber() {
		return (String) getValue(4);
	}

	/**
	 * Setter for <code>public.sent_sms.message</code>.
	 */
	public SentSmsRecord setMessage(String value) {
		setValue(5, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.message</code>.
	 */
	public String getMessage() {
		return (String) getValue(5);
	}

	/**
	 * Setter for <code>public.sent_sms.message_class</code>.
	 */
	public SentSmsRecord setMessageClass(SMSMessageClass value) {
		setValue(6, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.message_class</code>.
	 */
	public SMSMessageClass getMessageClass() {
		return (SMSMessageClass) getValue(6);
	}

	/**
	 * Setter for <code>public.sent_sms.encoding</code>.
	 */
	public SentSmsRecord setEncoding(SMSEncoding value) {
		setValue(7, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.encoding</code>.
	 */
	public SMSEncoding getEncoding() {
		return (SMSEncoding) getValue(7);
	}

	/**
	 * Setter for <code>public.sent_sms.sender_time</code>.
	 */
	public SentSmsRecord setSenderTime(Date value) {
		setValue(8, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.sender_time</code>.
	 */
	public Date getSenderTime() {
		return (Date) getValue(8);
	}

	/**
	 * Setter for <code>public.sent_sms.reference_number</code>.
	 */
	public SentSmsRecord setReferenceNumber(Integer value) {
		setValue(9, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.reference_number</code>.
	 */
	public Integer getReferenceNumber() {
		return (Integer) getValue(9);
	}

	/**
	 * Setter for <code>public.sent_sms.number_of_sms_part</code>.
	 */
	public SentSmsRecord setNumberOfSmsPart(Integer value) {
		setValue(10, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.number_of_sms_part</code>.
	 */
	public Integer getNumberOfSmsPart() {
		return (Integer) getValue(10);
	}

	/**
	 * Setter for <code>public.sent_sms.count_of_sms_parts</code>.
	 */
	public SentSmsRecord setCountOfSmsParts(Integer value) {
		setValue(11, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.count_of_sms_parts</code>.
	 */
	public Integer getCountOfSmsParts() {
		return (Integer) getValue(11);
	}

	/**
	 * Setter for <code>public.sent_sms.receipt_requested</code>.
	 */
	public SentSmsRecord setReceiptRequested(Boolean value) {
		setValue(12, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.receipt_requested</code>.
	 */
	public Boolean getReceiptRequested() {
		return (Boolean) getValue(12);
	}

	/**
	 * Setter for <code>public.sent_sms.delivery_status</code>.
	 */
	public SentSmsRecord setDeliveryStatus(DeliveryStatuses value) {
		setValue(13, value);
		return this;
	}

	/**
	 * Getter for <code>public.sent_sms.delivery_status</code>.
	 */
	public DeliveryStatuses getDeliveryStatus() {
		return (DeliveryStatuses) getValue(13);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Integer> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record14 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row14<Integer, ICCID, UUID, String, String, String, SMSMessageClass, SMSEncoding, Date, Integer, Integer, Integer, Boolean, DeliveryStatuses> fieldsRow() {
		return (Row14) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row14<Integer, ICCID, UUID, String, String, String, SMSMessageClass, SMSEncoding, Date, Integer, Integer, Integer, Boolean, DeliveryStatuses> valuesRow() {
		return (Row14) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Integer> field1() {
		return SentSms.SENT_SMS.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<ICCID> field2() {
		return SentSms.SENT_SMS.ICCID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<UUID> field3() {
		return SentSms.SENT_SMS.SMS_ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field4() {
		return SentSms.SENT_SMS.SMS_CENTER_NUMBER;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field5() {
		return SentSms.SENT_SMS.RECIPIENT_PHONE_NUMBER;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field6() {
		return SentSms.SENT_SMS.MESSAGE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<SMSMessageClass> field7() {
		return SentSms.SENT_SMS.MESSAGE_CLASS;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<SMSEncoding> field8() {
		return SentSms.SENT_SMS.ENCODING;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field9() {
		return SentSms.SENT_SMS.SENDER_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Integer> field10() {
		return SentSms.SENT_SMS.REFERENCE_NUMBER;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Integer> field11() {
		return SentSms.SENT_SMS.NUMBER_OF_SMS_PART;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Integer> field12() {
		return SentSms.SENT_SMS.COUNT_OF_SMS_PARTS;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Boolean> field13() {
		return SentSms.SENT_SMS.RECEIPT_REQUESTED;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<DeliveryStatuses> field14() {
		return SentSms.SENT_SMS.DELIVERY_STATUS;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Integer value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ICCID value2() {
		return getIccid();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UUID value3() {
		return getSmsId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value4() {
		return getSmsCenterNumber();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value5() {
		return getRecipientPhoneNumber();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value6() {
		return getMessage();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SMSMessageClass value7() {
		return getMessageClass();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SMSEncoding value8() {
		return getEncoding();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value9() {
		return getSenderTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Integer value10() {
		return getReferenceNumber();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Integer value11() {
		return getNumberOfSmsPart();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Integer value12() {
		return getCountOfSmsParts();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Boolean value13() {
		return getReceiptRequested();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public DeliveryStatuses value14() {
		return getDeliveryStatus();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value1(Integer value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value2(ICCID value) {
		setIccid(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value3(UUID value) {
		setSmsId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value4(String value) {
		setSmsCenterNumber(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value5(String value) {
		setRecipientPhoneNumber(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value6(String value) {
		setMessage(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value7(SMSMessageClass value) {
		setMessageClass(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value8(SMSEncoding value) {
		setEncoding(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value9(Date value) {
		setSenderTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value10(Integer value) {
		setReferenceNumber(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value11(Integer value) {
		setNumberOfSmsPart(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value12(Integer value) {
		setCountOfSmsParts(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value13(Boolean value) {
		setReceiptRequested(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord value14(DeliveryStatuses value) {
		setDeliveryStatus(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSmsRecord values(Integer value1, ICCID value2, UUID value3, String value4, String value5, String value6, SMSMessageClass value7, SMSEncoding value8, Date value9, Integer value10, Integer value11, Integer value12, Boolean value13, DeliveryStatuses value14) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		value5(value5);
		value6(value6);
		value7(value7);
		value8(value8);
		value9(value9);
		value10(value10);
		value11(value11);
		value12(value12);
		value13(value13);
		value14(value14);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached SentSmsRecord
	 */
	public SentSmsRecord() {
		super(SentSms.SENT_SMS);
	}

	/**
	 * Create a detached, initialised SentSmsRecord
	 */
	public SentSmsRecord(Integer id, ICCID iccid, UUID smsId, String smsCenterNumber, String recipientPhoneNumber, String message, SMSMessageClass messageClass, SMSEncoding encoding, Date senderTime, Integer referenceNumber, Integer numberOfSmsPart, Integer countOfSmsParts, Boolean receiptRequested, DeliveryStatuses deliveryStatus) {
		super(SentSms.SENT_SMS);

		setValue(0, id);
		setValue(1, iccid);
		setValue(2, smsId);
		setValue(3, smsCenterNumber);
		setValue(4, recipientPhoneNumber);
		setValue(5, message);
		setValue(6, messageClass);
		setValue(7, encoding);
		setValue(8, senderTime);
		setValue(9, referenceNumber);
		setValue(10, numberOfSmsPart);
		setValue(11, countOfSmsParts);
		setValue(12, receiptRequested);
		setValue(13, deliveryStatus);
	}
}
